#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
const int nmax = 1e5;

vector < int > upd[nmax + 1];
vector < long long > aib[nmax + 1];
int v[nmax + 1];
int poz[nmax + 1];
int x[nmax + 1];
int n;

void do_later ( int x, int y ) {
    for ( ; x <= n; x += x & -x )
        upd[x].push_back ( y );
}

void update ( int x, int y, int val ) {
    for ( ; x <= n; x += x &-x ) {
        int normy = ( lower_bound ( upd[x].begin (), upd[x].end (), y ) - upd[x].begin () );
        for ( int i = normy; i < aib[x].size (); i += i & -i )
            aib[x][i] += val;
    }
}

long long query ( int x, int y ) {
    long long s = 0;
    for ( ; x >= 1; x -= x &-x ) {
        int normy = ( upper_bound ( upd[x].begin (), upd[x].end (), y ) - upd[x].begin () ) - 1;
        for ( int i = normy; i > 0; i -= i & -i )
            s += aib[x][i];
    }
    return s;
}

int main() {
    ios_base::sync_with_stdio ( false );
    cin.tie ( 0 );
    cout.tie ( 0 );

    cin >> n;
    for ( int i = 1; i <= n; i++ ) {
        cin >> v[i];
        poz[v[i]] = i;
        do_later ( i, v[i] );
    }
    for ( int i = 1; i <= n - 2; i++ ) {
        cin >> x[i];
        do_later ( poz[x[i]], x[i] );
    }

    for ( int i = 1; i <= n; i++ ) {
        upd[i].push_back ( 0 );
        sort ( upd[i].begin (), upd[i].end () );
        aib[i].resize ( upd[i].size (), 0 );
    }

    long long total = 0;
    for ( int i = 1; i <= n; i++ ) {
        total += ( i - 1 ) - query ( i, v[i] );
        update ( i, v[i], +1 );
    }

    cout << total << ' ';

    for ( int i = 1; i <= n - 2; i++ ) {
        int big_st = query ( n, x[i] ) - query ( poz[x[i]], x[i] );
        int sml_dr = query ( poz[x[i]], n ) - query ( poz[x[i]], x[i] );
        total -= big_st + sml_dr;
        cout << total << ' ';

        update ( poz[x[i]], x[i], -1 );
    }

}
