#include <stdio.h>
#include <ctype.h>

#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

using oset = tree<int, null_type, std::less<int>, rb_tree_tag, tree_order_statistics_node_update>;

#define magic_sauce inline __attribute__((always_inline))

magic_sauce int fgetint(){
	int n = 0, ch;

	while( !isdigit( ch = fgetc( stdin ) ) );
	do
		n = n * 10 + ch - '0';
	while( isdigit( ch = fgetc( stdin ) ) );

	return n;
}

const int MAXN = 1e5;

int p[MAXN];
int inv[MAXN];
oset aib1[1 + MAXN];
oset aib2[1 + MAXN];
int n;
int rem;

magic_sauce int delx( int x ){
	int i = inv[x], delta = 0;

	while( i ){
		delta += aib1[i].size() - aib1[i].order_of_key( x );
		i &= (i - 1);
	}

	i = n - inv[x] - 1;
	while( i ){
		delta += aib2[i].order_of_key( x );
		i &= (i - 1);
	}

	// remove x from strucures
	i = inv[x] + 1;
	while( i <= n ){
		aib1[i].erase( aib1[i].find_by_order( aib1[i].order_of_key( x ) ) );
		i += (i & -i);
	}

	i = n - inv[x];
	while( i <= n ){
		aib2[i].erase( aib2[i].find_by_order( aib2[i].order_of_key( x ) ) );
		i += (i & -i);
	}

	return delta;
}

using ll = long long;

int main(){
	int i, j;
	ll ninv = 0;

	n = fgetint();
	for( i = 0 ; i < n ; i++ ){
		p[i] = fgetint() - 1;
		inv[p[i]] = i;
		
		j = i;
		while( j ){
			ninv += aib1[j].size() - aib1[j].order_of_key( p[i] );
			j &= (j - 1);
		}

		j = i + 1;
		while( j <= n ){
			aib1[j].insert( p[i] );
			j += (j & -j);
		}	

		j = n - i;
		while( j <= n ){
			aib2[j].insert( p[i] );
			j += (j & -j);
		}	
	}

	printf( "%lld", ninv );

	rem = n;
	for( i = n - 2 ; i-- ; ){
		ninv -= delx( fgetint() - 1 );
		rem--;

		printf( " %lld", ninv );
	}

	printf( "\n" );
	return 0;
}