/* Ignut
████████████████████████████████████████████████████████████████████
████████████████████████████████    ████████████████████████████████
██████████████████████████████        ██████████████████████████████
██████      ██████████████████        ██████████████████      ██████
██████          ██████████████        ██████████████          ██████
██████      ██    ████████████        ████████████    ██      ██████
██████      ████    ██████████        ██████████    ████      ██████
██████      ████      ██████████    ██████████      ████      ██████
██████      ████      ██████████    ██████████    ██████      ██████
██████      ██████    ██████████    ██████████    ██████      ██████
██████      ██████    ████████        ████████    ██████      ██████
██████      ██████      ██████        ██████      ██████      ██████
██████      ████        ████            ████        ████      ██████
██████            ██████████    ████    ██████████            ██████
██████      ██      ██████    ████████    ██████      ██      ██████
██████      ████              ████████              ████      ██████
██████      ██████████    ██            ██    ██████████      ██████
██████████████████████      ████    ████      ██████████████████████
████████████████████████      ██    ██      ████████████████████████
██████████████████████████                ██████████████████████████
██████████████████████████████        ██████████████████████████████
████████████████████████████████████████████████████████████████████
*/

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct SegmentTree {
    int sz;
    vector <int> tree;
    void Init(int n) {
        sz = 1;
        while (sz < n)
            sz <<= 1;
        tree.assign(sz * 2, 0);
    }
    void Inc(int v) {
        v += sz;
        while (v) {
            tree[v] ++;
            v >>= 1;
        }
    }
    int Sum(int v, int l, int r, int ql, int qr) {
        if (ql > r || qr < l)
            return 0;
        if (l >= ql && r <= qr) {
            //cout << '\n';
            //cout << v << " ---> full \n";
            return tree[v];
        }
        int m = (l + r) / 2;
        int s1 = Sum(v * 2, l, m, ql, qr);
        int s2 = Sum(v * 2 + 1, m + 1, r, ql, qr);
        return s1 + s2;
    }
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    /*#ifndef ONLINE_JUDGE
        freopen("input123.txt", "r", stdin);
        freopen("output123.txt", "w", stdout);
    #endif*/

    int n;
    cin >> n;
    SegmentTree st;
    st.Init(n);

    int res = 0;
    int subtract[n] = {};
    int a[n];
    for (int i = 0; i < n; i ++) {
        cin >> a[i];
        a[i] --;
        //cout << a[i] << " : " << st.Sum(1, 0, st.sz - 1, a[i], n - 1) << '\n';
        int s = st.Sum(1, 0, st.sz - 1, a[i], n - 1);
        subtract[a[i]] = s;
        res += s;
        st.Inc(a[i]);
        /*for (int i = st.sz; i < 2 * st.sz; i ++)
            cout << st.tree[i] << ' ';
        cout << '\n';
        */
    }
    cout << res << ' ';
    for (int i = 0; i < n - 2; i ++) {
        int val;
        cin >> val;
        val --;
        bool f = false;
        for (int j = 0; j < n; j ++) {
            if (a[j] == -1)
                continue;
            if (val == a[j]) {
                f = true;
                a[j] = -1;
                continue;
            }
            if (a[j] > val && !f)
                res --;
            if (a[j] < val && f)
                res --;
        }
        cout << res << ' ';
    }
    return 0;
}